UserModel userByIdFromJson(dynamic str) => (UserModel.fromJson(str));

class UserModel {
  late final String sId;
  late final String contactName;
  late final String companyName;
  late final String mobileNumber;
  late final String emailId;
  late final String altMobileNumber;
  late final String sTypename;

  UserModel(
      {required this.sId,
      required this.contactName,
      required this.companyName,
      required this.mobileNumber,
      required this.emailId,
      required this.altMobileNumber,
      required this.sTypename});

  UserModel.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    contactName = json['contactName'];
    companyName = json['companyName'];
    mobileNumber = json['mobileNumber'];
    emailId = json['emailId'];
    altMobileNumber = json['altMobileNumber'];
    sTypename = json['__typename'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['_id'] = this.sId;
    data['contactName'] = this.contactName;
    data['companyName'] = this.companyName;
    data['mobileNumber'] = this.mobileNumber;
    data['emailId'] = this.emailId;
    data['altMobileNumber'] = this.altMobileNumber;
    data['__typename'] = this.sTypename;
    return data;
  }
}

class UpdateUserProfileRequest {
  late final String? id;
  late final UpdateUserProfile? userInput;

  UpdateUserProfileRequest({
    this.id,
    this.userInput,
  });
}

class UpdateUserProfile {
  late final String? contactName;
  late final String? companyName;
  late final String? mobileNumber;
  late final String? emailId;
  late final String? altMobileNumber;
  late final String? gstNumber;

  UpdateUserProfile({
    this.contactName,
    this.companyName,
    this.mobileNumber,
    this.emailId,
    this.altMobileNumber,
    this.gstNumber,
  });

  UpdateUserProfile.fromJson(Map<String, dynamic> json) {
    contactName = json['contactName'];
    companyName = json['companyName'];
    mobileNumber = json['mobileNumber'];
    emailId = json['emailId'];
    altMobileNumber = json['altMobileNumber'];
    gstNumber = json['gstNumber'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();

    data['contactName'] = this.contactName;
    data['companyName'] = this.companyName;
    data['mobileNumber'] = this.mobileNumber;
    data['emailId'] = this.emailId;
    data['altMobileNumber'] = this.altMobileNumber;
    data['gstNumber'] = this.gstNumber;

    return data;
  }
}
