import 'package:b2b_graphql_package/modules/account/user_model.dart';

import 'password_available_model.dart';
import 'package:graphql_flutter/graphql_flutter.dart';

import '../../GraphQLConfiguration.dart';

class AuthRepo {
  var graphQLConfiguration;

  var checkPassword;
  var signInWithPassword;
  AuthRepo() {
    graphQLConfiguration = GraphQLConfiguration();
  }

  Future checkPasswordAvailability(String mobileNumber) async {
    GraphQLClient _client = graphQLConfiguration.clientToQuery();

    var checkPasswordGql = """ 
              query checkPassword(\$mobileNumber: String) {
              checkPassword(mobileNumber: \$mobileNumber) {
                _id
                password
                __typename
              }
            }
            """;

    final vble = {
      "mobileNumber": mobileNumber,
    };
    QueryResult result = await _client.query(QueryOptions(
      document: gql(checkPasswordGql),
      variables: vble,
      fetchPolicy: FetchPolicy.networkOnly,
    ));

    if (!result.hasException) {
      var checkPasswordModel = result.data!['checkPassword'];

      if (checkPasswordModel != null && checkPasswordModel.length > 0) {
        checkPassword = checkPasswordFromJson(checkPasswordModel);
        return checkPassword;
      }
    }
    return checkPassword;
  }

  Future signInWithMobileAndPassword(
      String mobileNumber, String password) async {
    GraphQLClient _client = graphQLConfiguration.clientToQuery();

    var signInGql = """ 
              query login(\$mobileNumber: String, \$password: String) {
              login(mobileNumber: \$mobileNumber, password: \$password) {
                _id
                   contactName
                  companyName
                  mobileNumber
                  emailId
                  altMobileNumber
                __typename
              }
            }
            """;

    final vble = {
      "mobileNumber": mobileNumber,
      "password": password,
    };
    QueryResult result = await _client.query(QueryOptions(
      document: gql(signInGql),
      variables: vble,
      fetchPolicy: FetchPolicy.networkOnly,
    ));

    if (!result.hasException) {
      var signInModel = result.data!['login'];

      if (signInModel != null && signInModel.length > 0) {
        signInWithPassword = userByIdFromJson(signInModel);
        return signInWithPassword;
      }
    }
    return signInWithPassword;
  }
}
