class CartModel {}

ServerCartCount cartCountFromJson(dynamic str) =>
    (ServerCartCount.fromJson(str));

class ServerCartCount {
  late final int serverCartCount;

  ServerCartCount({required this.serverCartCount});

  ServerCartCount.fromJson(int count) {
    serverCartCount = count;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['serverCartCount'] = this.serverCartCount;
    return data;
  }
}

List<Cart> cartListFromJson(dynamic str) =>
    List<Cart>.from(str.map((x) => Cart.fromJson(x)));

Cart cartFromJson(dynamic str) => (Cart.fromJson(str));

class Cart {
  late final String sId;
  late final String packName;
  late final String packId;
  late final String? packImage;
  late final String? packSku;
  late final String? setId;
  late final int? quantity;
  late final int? piece;
  late final int? setPrice;
  late final int? price;
  late final String? variant;
  late final double? igst;
  late final double? cgst;
  late final double? sgst;
  late final String? variantValue;
  late final bool? isOutofstock;
  late final int? maximumQuantity;
  late final String sTypename;

  Cart(
      {required this.sId,
      required this.packName,
      required this.packId,
      required this.packImage,
      required this.packSku,
      required this.setId,
      required this.quantity,
      required this.piece,
      required this.setPrice,
      required this.price,
      required this.variant,
      required this.igst,
      required this.cgst,
      required this.sgst,
      required this.variantValue,
      required this.isOutofstock,
      required this.maximumQuantity,
      required this.sTypename});

  Cart.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    packName = json['packName'];
    packId = json['packId'];
    packImage = json['packImage'];
    packSku = json['packSku'];
    setId = json['setId'];
    quantity = json['quantity'];
    piece = json['piece'];
    setPrice = json['setPrice'];
    price = json['price'];
    variant = json['variant'];
    igst = json['igst'];
    cgst = json['cgst'];
    sgst = json['sgst'];
    variantValue = json['variantValue'];
    isOutofstock = json['isOutofstock'];
    maximumQuantity = json['maximumQuantity'];
    sTypename = json['__typename'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['_id'] = this.sId;
    data['packName'] = this.packName;
    data['packId'] = this.packId;
    data['packImage'] = this.packImage;
    data['packSku'] = this.packSku;
    data['setId'] = this.setId;
    data['quantity'] = this.quantity;
    data['piece'] = this.piece;
    data['setPrice'] = this.setPrice;
    data['price'] = this.price;
    data['variant'] = this.variant;
    data['igst'] = this.igst;
    data['cgst'] = this.cgst;
    data['sgst'] = this.sgst;
    data['variantValue'] = this.variantValue;
    data['isOutofstock'] = this.isOutofstock;
    data['maximumQuantity'] = this.maximumQuantity;
    data['__typename'] = this.sTypename;
    return data;
  }
}

RemoveCart removeCartFromJson(dynamic str) => (RemoveCart.fromJson(str));

class RemoveCart {
  late final int removeCart;

  RemoveCart({required this.removeCart});

  RemoveCart.fromJson(Map<String, dynamic> json) {
    removeCart = json['removeCart'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['removeCart'] = this.removeCart;
    return data;
  }
}

class UpdateCartRequest {
  late final String id;
  late final CartRequest cart;

  UpdateCartRequest({required this.id, required this.cart});
}

class CartRequest {
  late final int quantity;

  CartRequest({
    required this.quantity,
  });

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['quantity'] = this.quantity;
    return data;
  }
}

class AddCartRequest {
  late final String packId;
  late final int quantity;
  late final String setId;
  late final String userId;

  AddCartRequest(
      {required this.packId,
      required this.quantity,
      required this.setId,
      required this.userId});

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['packId'] = this.packId;
    data['quantity'] = this.quantity;
    data['setId'] = this.setId;
    data['userId'] = this.userId;
    return data;
  }
}

AddCart addCartFromJson(dynamic str) => (AddCart.fromJson(str));

class AddCart {
  late final int addCart;

  AddCart({required this.addCart});

  AddCart.fromJson(Map<String, dynamic> json) {
    addCart = json['addCart'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['addCart'] = this.addCart;
    return data;
  }
}
