List<CategoryPackWithSet> categoryPackWithSetListFromJson(dynamic str) =>
    List<CategoryPackWithSet>.from(
        str.map((x) => CategoryPackWithSet.fromJson(x)));

CategoryPackWithSet categoryPackWithSetFromJson(dynamic str) =>
    (CategoryPackWithSet.fromJson(str));

class CategoryPackWithSet {
  late final List<Pack> pack;
  late final int? currentPage;
  late final int? totalPages;
  late final int? count;
  late final String sTypename;

  CategoryPackWithSet(
      {required this.pack,
      required this.currentPage,
      required this.totalPages,
      required this.count,
      required this.sTypename});

  CategoryPackWithSet.fromJson(Map<String, dynamic> json) {
    if (json['pack'] != null) {
      pack = [];
      json['pack'].forEach((v) {
        pack.add(new Pack.fromJson(v));
      });
    }
    currentPage = json['currentPage'];
    totalPages = json['totalPages'];
    count = json['count'];
    sTypename = json['__typename'];
  }
}

class Pack {
  late final String sId;
  late final String? packSKU;
  late final int? moq;
  late final List<PackImages> packImages;
  late final String? packName;
  late final String? packVariant;
  late final HeadSetInformation? headSetInformation;
  late final String sTypename;

  Pack(
      {required this.sId,
      required this.packSKU,
      required this.moq,
      required this.packImages,
      required this.packName,
      required this.packVariant,
      required this.headSetInformation,
      required this.sTypename});

  Pack.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    packSKU = json['packSKU'];
    moq = json['moq'];
    if (json['packImages'] != null) {
      packImages = [];
      json['packImages'].forEach((v) {
        packImages.add(new PackImages.fromJson(v));
      });
    }
    packName = json['packName'];
    packVariant = json['packVariant'];
    headSetInformation = json['headSetInformation'] != null
        ? new HeadSetInformation.fromJson(json['headSetInformation'])
        : null;
    sTypename = json['__typename'];
  }
}

class PackImages {
  late final String? packImageName;
  late final String sTypename;

  PackImages({required this.packImageName, required this.sTypename});

  PackImages.fromJson(Map<String, dynamic> json) {
    packImageName = json['packImageName'];
    sTypename = json['__typename'];
  }
}

class HeadSetInformation {
  late final int? setPrice;
  late final int? setQuantity;
  late final String sTypename;

  HeadSetInformation(
      {required this.setPrice,
      required this.setQuantity,
      required this.sTypename});

  HeadSetInformation.fromJson(Map<String, dynamic> json) {
    setPrice = json['setPrice'];
    setQuantity = json['setQuantity'];
    sTypename = json['__typename'];
  }
}
