import 'package:graphql_flutter/graphql_flutter.dart';

import '../../GraphQLConfiguration.dart';
import 'category_pack_model.dart';

class CategoryPackWithSetRepo {
  var graphQLConfiguration;

  var categoryPackWithSet;
  CategoryPackWithSetRepo() {
    graphQLConfiguration = GraphQLConfiguration();
  }

  Future<CategoryPackWithSet> getCategoryPackWithSet(
      String categoryLink, int page, int limit, List filter) async {
    GraphQLClient _client = graphQLConfiguration.clientToQuery();

    var categoryPackGql = """ 
                  query getCategoryPackWithSet(
                    \$categoryLink: String
                    \$page: Int
                    \$limit: Int
                    \$filter: [FilterAttribute]
                  ) {
                    getCategoryPackWithSet(
                      categoryLink: \$categoryLink
                      page: \$page
                      limit: \$limit
                      filter: \$filter
                    ) {
                      pack {
                        _id
                        packSKU
                        moq
                        packImages {
                          packImageName
                          __typename
                        }
                        packName
                        packVariant
                        headSetInformation {
                          setPrice
                          setQuantity
                          __typename
                        }
                        __typename
                      }
                      currentPage
                      totalPages
                      count
                      __typename
                    }
                  }

            """;

    final vble = {
      "categoryLink": categoryLink,
      "page": page,
      "limit": limit,
      "filter": filter
    };
    QueryResult result = await _client.query(QueryOptions(
      document: gql(categoryPackGql),
      variables: vble,
      fetchPolicy: FetchPolicy.networkOnly,
    ));

    if (!result.hasException) {
      var categoryPack = result.data!['getCategoryPackWithSet'];

      if (categoryPack != null && categoryPack.length > 0) {
        categoryPackWithSet = categoryPackWithSetFromJson(categoryPack);
      }
      return categoryPackWithSet;
    }
    return categoryPackWithSet;
  }
}
