import 'package:graphql_flutter/graphql_flutter.dart';

import '../../GraphQLConfiguration.dart';

import './chcekout_model.dart';

class CheckoutRepo {
  var graphQLConfiguration;

  var delhivaryFees;
  CheckoutRepo() {
    graphQLConfiguration = GraphQLConfiguration();
  }

  Future getDelhiveryShippingFees(
      int deliveryPincode, double weight, String providerName) async {
    GraphQLClient _client = graphQLConfiguration.clientToQuery();

    var delhiveryShippingFeeGql = """ 
                 query getDelhiveryShippingFees(
                \$deliveryPincode: Float
                \$weight: Float
                \$providerName: String
              ) {
                getDelhiveryShippingFees(
                  deliveryPincode: \$deliveryPincode
                  weight: \$weight
                  providerName: \$providerName
                ) {
                  fees
                  shippingIGST
                  shippingSGST
                  shippingCGST
                  __typename
                }
              }
            """;

    final vble = {
      "deliveryPincode": deliveryPincode,
      "weight": weight,
      "providerName": providerName,
    };
    QueryResult result = await _client.query(QueryOptions(
      document: gql(delhiveryShippingFeeGql),
      variables: vble,
      fetchPolicy: FetchPolicy.networkOnly,
    ));

    if (!result.hasException) {
      var shippingFees = result.data!['getDelhiveryShippingFees'];

      if (shippingFees != null) {
        delhivaryFees = delhiveryShippingFeesFromJson(shippingFees);
      }
      return delhivaryFees;
    }
    return delhivaryFees;
  }
}
