List<MenuCategoryModel> menuCategoryListFromJson(dynamic str) =>
    List<MenuCategoryModel>.from(str.map((x) => MenuCategoryModel.fromJson(x)));

class MenuCategoryModel {
  late final String sId;
  late final bool status;
  late final int? sortOrder;
  late final CategoryDetails? categoryDetails;

  MenuCategoryModel({
    required this.sId,
    required this.status,
    this.sortOrder,
    this.categoryDetails,
  });

  MenuCategoryModel.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    status = json['status'];
    sortOrder = json['sortOrder'];
    categoryDetails = (json['categoryDetails']) != null
        ? new CategoryDetails.fromJson(json['categoryDetails'])
        : null;
  }
}

class CategoryDetails {
  late final String sId;
  late final String categoryName;
  late final String categoryId;
  late final bool status;
  late final List<Childrens> children;

  CategoryDetails({
    required this.sId,
    required this.categoryName,
    required this.categoryId,
    required this.status,
    required this.children,
  });

  CategoryDetails.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    categoryName = json['categoryName'];
    categoryId = json['categoryId'];
    status = json['status'];
    if (json['children'] != null) {
      children = [];
      json['children'].forEach((v) {
        children.add(new Childrens.fromJson(v));
      });
    }
  }
}

// class Children {
//   late final String sId;
//   late final String categoryName;
//   late final String categoryId;
//   late final bool status;
//   late final String link;
//   late final List<Children> children;
//   late final String sTypename;

//   Children(
//       {required this.sId,
//       required this.categoryName,
//       required this.categoryId,
//       required this.status,
//       required this.link,
//       required this.children,
//       required this.sTypename});

//   Children.fromJson(Map<String, dynamic> json) {
//     sId = json['_id'];
//     categoryName = json['categoryName'];
//     categoryId = json['categoryId'];
//     status = json['status'];
//     link = json['link'];
//     if (json['children'] != null) {
//       children = [];
//       json['children'].forEach((v) {
//         children.add(new Children.fromJson(v));
//       });
//     }
//     sTypename = json['__typename'];
//   }
// }

class Childrens {
  late final String sId;
  late final String categoryName;
  late final String categoryId;
  late final bool status;
  late final List<Children> children;
  late final String sTypename;

  Childrens(
      {required this.sId,
      required this.categoryName,
      required this.categoryId,
      required this.status,
      required this.children,
      required this.sTypename});

  Childrens.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    categoryName = json['categoryName'];
    categoryId = json['categoryId'];
    status = json['status'];
    if (json['children'] != null) {
      children = [];
      json['children'].forEach((v) {
        children.add(new Children.fromJson(v));
      });
    }
    sTypename = json['__typename'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['_id'] = this.sId;
    data['categoryName'] = this.categoryName;
    data['categoryId'] = this.categoryId;
    data['status'] = this.status;
    if (this.children != null) {
      data['children'] = this.children.map((v) => v.toJson()).toList();
    }
    data['__typename'] = this.sTypename;
    return data;
  }
}

class Children {
  late final String sId;
  late final String? link;
  late final String categoryName;
  late final String categoryId;
  late final bool status;
  late final List<dynamic> children;
  late final String sTypename;

  Children(
      {required this.sId,
      required this.link,
      required this.categoryName,
      required this.categoryId,
      required this.status,
      required this.children,
      required this.sTypename});

  Children.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    link = json['link'];
    categoryName = json['categoryName'];
    categoryId = json['categoryId'];
    status = json['status'];
    if (json['children'] != null) {
      children = [];
      json['children'].forEach((v) {
        children.add(v);
      });
    }
    sTypename = json['__typename'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['_id'] = this.sId;
    data['link'] = this.link;
    data['categoryName'] = this.categoryName;
    data['categoryId'] = this.categoryId;
    data['status'] = this.status;
    if (this.children != null) {
      data['children'] = this.children.map((v) => v.toJson()).toList();
    }
    data['__typename'] = this.sTypename;
    return data;
  }
}
